<script lang="ts" setup>
import { reactive, onMounted } from "vue";
import { useTheme } from "vuetify";

const state = reactive({
  light: true,
  auto: true,
});

const theme = useTheme();

function setMode(light: boolean, auto: boolean) {
  state.light = light;
  state.auto = auto;
  document.documentElement.setAttribute(
    "data-theme",
    state.light ? "light" : "dark"
  );
  theme.global.name.value = state.light ? "light" : "dark";
  // console.log(`state.light = ${state.light}, state.auto = ${state.auto}`);
  localStorage.setItem("saved-theme", auto ? "auto" : light ? "light" : "dark");
}

function useAutoMode() {
  const hasDarkPreference = window.matchMedia(
    "(prefers-color-scheme: dark)"
  ).matches;
  setMode(!hasDarkPreference, true);
}

function switchMode() {
  const hasDarkPreference = window.matchMedia(
    "(prefers-color-scheme: dark)"
  ).matches;
  if (!state.auto && state.light !== hasDarkPreference) {
    useAutoMode();
  } else {
    setMode(!state.light, false);
  }
}

onMounted(() => {
  const savedTheme = localStorage.getItem("saved-theme");
  if (savedTheme !== "auto") {
    setMode(savedTheme !== "dark", false);
  } else {
    useAutoMode();
  }
});
</script>

<template>
  <div
    class="p-2 hover:bg-theme-text-link-hover transition-colors ease-in-out rounded-full flex justify-center content-center items-center cursor-pointer"
    @click="switchMode"
  >
    <!-- Auto -->
    <svg
      v-if="state.auto"
      height="24"
      viewBox="0 0 384 512"
      xmlns="http://www.w3.org/2000/svg"
    >
      <path
        d="M381.5 435.7l-160-384C216.6 39.78 204.9 32.01 192 32.01S167.4 39.78 162.5 51.7l-160 384c-6.797 16.31 .9062 35.05 17.22 41.84c16.38 6.828 35.08-.9219 41.84-17.22l31.8-76.31h197.3l31.8 76.31c5.109 12.28 17.02 19.7 29.55 19.7c4.094 0 8.266-.7969 12.3-2.484C380.6 470.7 388.3 452 381.5 435.7zM119.1 320L192 147.2l72 172.8H119.1z"
      />
    </svg>
    <!-- Sun -->
    <svg
      v-if="!state.auto && state.light"
      height="24"
      viewBox="0 0 24 24"
      width="24"
      xmlns="http://www.w3.org/2000/svg"
    >
      <circle cx="12" cy="12" r="5" />
      <path d="M21,13H20a1,1,0,0,1,0-2h1a1,1,0,0,1,0,2Z" />
      <path d="M4,13H3a1,1,0,0,1,0-2H4a1,1,0,0,1,0,2Z" />
      <path
        d="M17.66,7.34A1,1,0,0,1,17,7.05a1,1,0,0,1,0-1.41l.71-.71a1,1,0,1,1,1.41,1.41l-.71.71A1,1,0,0,1,17.66,7.34Z"
        fill="#464646"
      />
      <path
        d="M5.64,19.36a1,1,0,0,1-.71-.29,1,1,0,0,1,0-1.41L5.64,17a1,1,0,0,1,1.41,1.41l-.71.71A1,1,0,0,1,5.64,19.36Z"
        fill="#464646"
      />
      <path
        d="M12,5a1,1,0,0,1-1-1V3a1,1,0,0,1,2,0V4A1,1,0,0,1,12,5Z"
        fill="#464646"
      />
      <path
        d="M12,22a1,1,0,0,1-1-1V20a1,1,0,0,1,2,0v1A1,1,0,0,1,12,22Z"
        fill="#464646"
      />
      <path
        d="M6.34,7.34a1,1,0,0,1-.7-.29l-.71-.71A1,1,0,0,1,6.34,4.93l.71.71a1,1,0,0,1,0,1.41A1,1,0,0,1,6.34,7.34Z"
        fill="#464646"
      />
      <path
        d="M18.36,19.36a1,1,0,0,1-.7-.29L17,18.36A1,1,0,0,1,18.36,17l.71.71a1,1,0,0,1,0,1.41A1,1,0,0,1,18.36,19.36Z"
        fill="#464646"
      />
    </svg>
    <!-- Moon -->
    <svg
      v-if="!state.auto && !state.light"
      height="24"
      viewBox="0 0 512 512"
      width="24"
      xmlns="http://www.w3.org/2000/svg"
    >
      <title />
      <path
        d="M264,480A232,232,0,0,1,32,248C32,154,86,69.72,169.61,33.33a16,16,0,0,1,21.06,21.06C181.07,76.43,176,104.66,176,136c0,110.28,89.72,200,200,200,31.34,0,59.57-5.07,81.61-14.67a16,16,0,0,1,21.06,21.06C442.28,426,358,480,264,480Z"
      />
    </svg>
  </div>
</template>

<style scoped>
svg path {
  fill: var(--theme-text);
}

svg circle {
  fill: var(--theme-text);
}
</style>
